#This API returns the current number of people in space.
#When known it also returns the names and spacecraft those people are on.
#This API takes no inputs.

#start by importing requests (this is what we installed before using the pip installer)

import requests

#Now we can use the functionality gained from the requests
#Below we will use the function requests.get() and the URL of the
#Open Notify API

Astronauts = requests.get('http://api.open-notify.org/astros.json')

#And just like that we now have all the information desired. So by uncommenting below
#you can print exactly the data returned by Open Notify API to the Python IDLE Shell
#You will notice the data is messy and not easily ledgible. Uncommment by deleting # symbol.

#print('Below is the raw data pulled from the OpenNotifyAPI: \n')
#print(Astronauts.text)
#print(' ')

#If your curious about status codes below uncomment this below. The \n makes a paragraph break

#print('The status code for this API request is', Astronauts.status_code, "\n")

#This data comes out not looking pretty. So lets make the data more readable in a Python way.
#This means we can alter it better. The function .json() will be the method to do this.
#Requests Package has a built in json decode method, that can turn the API data into a native
#Python datatype making it easier for Python to understand.

#Below turns the API Data sent into a Python dictionary with key value pairs.
Astronauts_datafix = Astronauts.json()

#Uncomment below to print this value so you can see it. Comparing it to the oringial data from
#OpenNotifyAPI it appears nothing has changed changed with the data.
#Uncomments the 2 lines beneath to see the data type has changed to a dict.
#This is good for Python to read the data.

#print('Below is the modified data pulled from the OpenNotifyAPI (looks the same as above but different type: \n')
#print(Astronauts_datafix)
#print(' ')

#print('Original API data is a', type(Astronauts))
#print('Modified API data is a', type(Astronauts_datafix))
#print(' ')

#Now let me demonstrate just the values we desire being printed to IDLE, this being the
#number of astronauts in space and a list of the people in space. This is easy to do
#because we changed the API data to a dictonary type.
print("The number of people in outer space is", Astronauts_datafix['number'], '! \n')
print('Below are the names of the current space people:')

#Below is a small loop which goes through all the people in the altered API data
#and prints their name to the Python IDLE Shell
for i in Astronauts_datafix["people"]:
    print (i["name"])


