#Imagine that this script is run every morning, informing you what the weather will be
#and telling you whether you need to turn the sprinklers on or off. A future
#step would be to turn the sprinklers on or off automatically.

#Start by importing pyowm (this is what we installed before using the pip installer).
import pyowm

#Now we can use the functionality gained from pyowm in our code.

#To access the OpenWeatherMapAPI we must have a API Key which is sent
#with our request to use data from OpenWeatherMap
#This is done by using the function owm=pyowm.OWM() and our unique APIkey.
owm = pyowm.OWM('a0c664323ffe4b57a627f7585eea0748')

#Now we can decide the location of the weather data we desire. You can also use
#latitude and longitude to decide location. The world is your oyster.
city = 'Glasgow'

#Now we utilise the functionality provided by pyowm to get the weather at our
#desired location
loc = owm.weather_manager().weather_at_place(city)

#Below is an example of using latitude and longitude to get weather data from
#OpenWeatherMap API. Uncomment below and comment above to make this run.
#use the latitude and longitude values of your choice.
#loc = owm.weather_manager().weather_at_coords(34, 150)

#Below gives a variable name to the data we have pulled from OpenWeatherAPI
weather = loc.weather

#To see the raw data that you have pulled from the API uncomment the two lines below
#print(weather)

#Below is taking the data we desire from the OpenWeatherAPI and grabbing only what we desire
temp = weather.temperature(unit='celsius')
status = weather.detailed_status

#Cleaning up the tenp data is done below so we have just the average value
cleaned_temp_data = (int(temp['temp']))

#Print the weather details to Python IDLE shell in a human readable manner
print('The temperature today in', city,'is',cleaned_temp_data,'degrees celsius.')
print('The day today will have',status,'.')

#Now to decide whether to inform the human to turn sprinklers on or off.

#The Status variabel is a class string variable. Uncomment what is below to demonstrates
#this. Thus means we can search it looking for the string 'rain' inside of it.
#print(type(status)) 

#Using an if statement we can decide whether to sprinkler or not to sprinkler.
#This is done by searching for rain in status or anything rain-esque.

if 'rain' in status or 'thunderstorm' in status or 'drizzle' in status or 'snow' in status:

    print('No need for sprinklers today. Time to turn them off.')
    
else:
    
    print('Sprinklers are needed today. Time to turn them on.')

#In a future video I'll dive into the specifics of automating sprinklers from Python code. 
